package asmc

import (
	"git.urbach.dev/cli/q/src/config"
	"git.urbach.dev/cli/q/src/elf"
	"git.urbach.dev/cli/q/src/exe"
	"git.urbach.dev/cli/q/src/macho"
	"git.urbach.dev/cli/q/src/pe"
)

// codeOffset returns the file offset of the code section.
func codeOffset() int {
	headerEnd := 0

	switch config.TargetOS {
	case config.Linux:
		headerEnd = elf.HeaderEnd
	case config.Mac:
		headerEnd = macho.HeaderEnd
	case config.Windows:
		headerEnd = pe.HeaderEnd
	}

	return exe.Align(headerEnd, config.FileAlign)
}
