package asmc

import (
	"strings"

	"git.urbach.dev/cli/q/src/asm"
	"git.urbach.dev/cli/q/src/x86"
)

func (c *compiler) dllCall(x asm.Instruction) {
	c.code = x86.CallAt(c.code, 0x00_00_00_00)
	next := Address(len(c.code))
	position := next - 4
	label := x.Data.(*asm.Label)

	pointer := &pointer{
		Position: Address(position),
		OpSize:   2,
		Size:     4,
	}

	pointer.Resolve = func() Address {
		dot := strings.Index(label.Name, ".")
		library := label.Name[:dot]
		funcName := label.Name[dot+1:]
		index := c.dlls.Index(library, funcName)

		if index == -1 {
			panic("unknown DLL function " + label.Name)
		}

		destination := c.importsStart + Address(index*8)
		from := c.codeStart + next
		return destination - from
	}

	c.dllPointers = append(c.dllPointers, pointer)
}
