package cli

import (
	"fmt"
	"io"
)

// Help shows the command line argument usage.
func Help(w io.Writer, code int) int {
	fmt.Fprintln(w, `Usage:

    q [command] [options]

Commands:

    build [directory | file]       build an executable from a file or directory
        --arch [arch]                  cross-compile for CPU: [x86|arm]
        --assembly, -a                 show assembly instructions
        --dry                          skip writing the executable to disk
        --os [os]                      cross-compile for OS: [linux|mac|windows]
        --sections                     add sections to the executable
        --statistics                   show statistics
        --verbose, -v                  show everything

    run [directory | file]         build and run the executable
    system                         show system information
    help                           show this help`)
	return code
}
