package elf

const (
	LittleEndian      = 1
	TypeExecutable    = 2
	ArchitectureAMD64 = 0x3E
	ArchitectureARM64 = 0xB7
)

type ProgramType int32

const (
	ProgramTypeNULL    ProgramType = 0
	ProgramTypeLOAD    ProgramType = 1
	ProgramTypeDYNAMIC ProgramType = 2
	ProgramTypeINTERP  ProgramType = 3
	ProgramTypeNOTE    ProgramType = 4
	ProgramTypeSHLIB   ProgramType = 5
	ProgramTypePHDR    ProgramType = 6
	ProgramTypeTLS     ProgramType = 7
)

type ProgramFlags int32

const (
	ProgramFlagsExecutable ProgramFlags = 0x1
	ProgramFlagsWritable   ProgramFlags = 0x2
	ProgramFlagsReadable   ProgramFlags = 0x4
)

type SectionType int32

const (
	SectionTypeNULL     SectionType = 0
	SectionTypePROGBITS SectionType = 1
	SectionTypeSYMTAB   SectionType = 2
	SectionTypeSTRTAB   SectionType = 3
	SectionTypeRELA     SectionType = 4
	SectionTypeHASH     SectionType = 5
	SectionTypeDYNAMIC  SectionType = 6
	SectionTypeNOTE     SectionType = 7
	SectionTypeNOBITS   SectionType = 8
	SectionTypeREL      SectionType = 9
	SectionTypeSHLIB    SectionType = 10
	SectionTypeDYNSYM   SectionType = 11
)

type SectionFlags int64

const (
	SectionFlagsWritable   SectionFlags = 1 << 0
	SectionFlagsAllocate   SectionFlags = 1 << 1
	SectionFlagsExecutable SectionFlags = 1 << 2
	SectionFlagsStrings    SectionFlags = 1 << 5
	SectionFlagsTLS        SectionFlags = 1 << 10
)
